package org.jcg.zheng;

import static org.junit.Assert.assertEquals;

import java.nio.charset.StandardCharsets;
import java.util.Arrays;

import org.junit.Test;

public class ByteArrayToStringTest {

    private static final String MARY = "Mary";
    private byte[] TEST_BYTES_ARR = new byte[] { 77, 97, 114, 121 };

    @Test
    public void test_default() {
        String newString = new String(TEST_BYTES_ARR);
        assertEquals(MARY, newString);
    }

    @Test
    public void test_utf8() {
        String newString = new String(TEST_BYTES_ARR, StandardCharsets.UTF_8);
        assertEquals(MARY, newString);
    }

    @Test
    public void test_ascii() {
        String newString = new String(TEST_BYTES_ARR, StandardCharsets.US_ASCII);
        assertEquals(MARY, newString);
    }

    @Test
    public void test_iso_8859() {
        String stringTextOfByteArray = new String(TEST_BYTES_ARR, StandardCharsets.ISO_8859_1);
        assertEquals(MARY, stringTextOfByteArray);
    }

    @Test
    public void test_utf_16() {
        String stringTextOfByteArray = new String(TEST_BYTES_ARR, StandardCharsets.UTF_16);
        assertEquals("䵡特", stringTextOfByteArray);
    }

    @Test
    public void test_utf16Be() {
        String newString = new String(TEST_BYTES_ARR, StandardCharsets.UTF_16BE);
        assertEquals("䵡特", newString);
    }

    @Test
    public void test_utf16Le() {
        String newString = new String(TEST_BYTES_ARR, StandardCharsets.UTF_16LE);
        assertEquals("慍祲", newString);
    }

    @Test
    public void toStringFormat() {
        String stringRepresntationOfByteArray = Arrays.toString(TEST_BYTES_ARR);
        assertEquals("[77, 97, 114, 121]", stringRepresntationOfByteArray);
    }
}
